Ice Reference Documentation
<<< Previous | Properties | Next >>>

# Glacier2 Properties

## Glacier2.AddUserToAllowCategories

### Synopsis

    Glacier2.AddUserToAllowCategories=num

### Description

Specifies whether to add an authenticated user id to the `Glacier2.AllowCategories` property upon the creation of a new session. The legal values are shown below:

0 | Do not add the user id. (default)
1 | Add the user id.
2 | Add the user id with a leading underscore.

## Glacier2.Admin.Endpoints

### Synopsis

    Glacier2.Admin.Endpoints=endpoints

### Description

Defines the optional administrative endpoints of the Glacier2 admin interface. The administrative endpoints must be accessible to clients that are using the Glacier2 admin interface.

| Allowing access to the Glacier2 admin interface is a security risk! If this property is not defined, the admin interface is disabled.

## Glacier2.Admin.PublishedEndpoints

### Synopsis

    Glacier2.Admin.PublishedEndpoints=endpoints

### Description

Defines the optional administrative published endpoints of the Glacier2 admin interface. The administrative endpoints must be accessible to clients that are using the Glacier2 administrative interface. Refer to the description of the object adapter property `adapter`.PublishedEndpoints for more information.

| Allowing access to the Glacier2 admin interface is a security risk!

## Glacier2.InstanceName

### Synopsis

    Glacier2.InstanceName=name

### Description

Specifies a default identity category for the Glacier2 objects. If defined, the identity of the Glacier2 admin interface becomes `name``/admin` and the identity of the Glacier2 router interface becomes `name``/router`. The deprecated properties `Glacier2.AdminIdentity` and `Glacier2.RouterIdentity` take precedence.

If not otherwise defined, the default identities of the Glacier2 objects are `Glacier2/admin` and `Glacier2/router`.

## Glacier2.AdminIdentity

### Synopsis

    Glacier2.AdminIdentity=identity

### Description

The identity of the Glacier2 admin interface. If not specified, the default value `Glacier2/admin` is used.

| This property is deprecated and supported only for backward-compatibility. New applications should use Glacier2.InstanceName.

## Glacier2.AllowCategories

### Synopsis

    Glacier2.AllowCategories=list

### Description

Specifies a whitespace-separated list of identity categories. If this property is defined, then the Glacier2 router only allows requests to Ice objects with an identity that matches one of the categories from this list. If `Glacier2.AddUserToAllowCategories` is defined with a non-zero value, the router automatically adds the user id of each session to this list.

## Glacier2.Client.AlwaysBatch

### Synopsis

    Glacier2.Client.AlwaysBatch=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router always batches queued oneway requests from clients to servers regardless of the value of their `_fwd` contexts. This property is only relevant when `Glacier2.Client.Buffered=1`. The default value is 0.

## Glacier2.Client.Endpoints

### Synopsis

    Glacier2.Client.Endpoints=endpoints

### Description

Defines the client endpoints of the Glacier2 router. These endpoints must be accessible to router clients. Use of a secure transport is highly recommended.

## Glacier2.Client.PublishedEndpoints

### Synopsis

    Glacier2.Client.PublishedEndpoints=endpoints

### Description

Defines the published client endpoints of the Glacier2 router. These endpoints must be accessible to router clients. Use of a secure transport is highly recommended. Refer to the description of the object adapter property `adapter`.PublishedEndpoints for more information.

## Glacier2.Client.ForwardContext

### Synopsis

    Glacier2.Client.ForwardContext=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router includes the context in forwarded requests from clients to servers. The default value is 0.

## Glacier2.Client.SleepTime

### Synopsis

    Glacier2.Client.SleepTime=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router sleeps for the specified number of milliseconds after forwarding all queued requests from a client. This prevents the client from flooding the router with requests. This property is only relevant when `Glacier2.Client.Buffered=1`. The default value is 0.

## Glacier2.Client.Trace.Override

### Synopsis

    Glacier2.Client.Trace.Override=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message whenever a request was overridden. The default value is 0.

## Glacier2.Client.Trace.Reject

### Synopsis

    Glacier2.Client.Trace.Reject=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message whenever it rejects a client's request because its identity category did not match one of the entries in `Glacier2.AllowCategories`. The default value is 0.

## Glacier2.Client.Trace.Request

### Synopsis

    Glacier2.Client.Trace.Request=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message for each request that is forwarded from a client. The default value is 0.

## Glacier2.Client.Buffered

### Synopsis

    Glacier2.Client.Buffered=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router queues incoming requests from clients and creates an extra thread for each client connection that processes the queued requests. If `num` is set to zero, the router operates in unbuffered mode in which a request is forwarded in the same thread that received it. The default value is 1.

| In unbuffered mode, twoway requests from a client are serialized, and nested twoway requests are not supported.

## Glacier2.CryptPasswords

### Synopsis

    Glacier2.CryptPasswords=file

### Description

Specifies the filename of a Glacier2 access control list. Each line of the file must contain a username and a password, separated by whitespace. The password must be a 13-character, crypt-encoded string. If this property is not defined, the default value is `passwords`. This property is ignored if `Glacier2.PermissionsVerifier` is defined.

## Glacier2.PermissionsVerifier

### Synopsis

    Glacier2.PermissionsVerifier=proxy

### Description

Specifies the proxy of an object that implements the `Glacier2::PermissionsVerifier` interface. The router invokes this proxy to validate each new session created by a client.

## Glacier2.RouterIdentity

### Synopsis

    Glacier2.RouterIdentity=identity

### Description

The identity of the Glacier2 router interface. If not specified, the default value `Glacier2/router` is used.

| This property is deprecated and supported only for backward-compatibility. New applications should use Glacier2.InstanceName.

## Glacier2.Server.AlwaysBatch

### Synopsis

    Glacier2.Server.AlwaysBatch=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router always batches queued oneway requests from servers to clients regardless of the value of their `_fwd` contexts. This property is only relevant when `Glacier2.Server.Buffered=1`. The default value is 0.

## Glacier2.Server.Endpoints

### Synopsis

    Glacier2.Server.Endpoints=endpoints

### Description

Defines the server endpoints of the Glacier2 router. These endpoints must be accessible to back end servers.

## Glacier2.Server.PublishedEndpoints

### Synopsis

    Glacier2.Server.PublishedEndpoints=endpoints

### Description

Defines the published server endpoints of the Glacier2 router. These endpoints must be accessible to back end servers. Refer to the description of the object adapter property `adapter`.PublishedEndpoints for more information.

## Glacier2.Server.ForwardContext

### Synopsis

    Glacier2.Server.ForwardContext=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router includes the context in forwarded requests from servers to clients. The default value is 0.

## Glacier2.Server.SleepTime

### Synopsis

    Glacier2.Server.SleepTime=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router sleeps for the specified number of milliseconds after forwarding all queued requests from a server. This prevents the server from flooding the router with requests. This property is only relevant when `Glacier2.Server.Buffered=1`. The default value is 0.

## Glacier2.Server.Trace.Override

### Synopsis

    Glacier2.Server.Trace.Override=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message whenever a request was overridden. The default value is 0.

## Glacier2.Server.Trace.Request

### Synopsis

    Glacier2.Server.Trace.Request=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message for each request that is forwarded from a server. The default value is 0.

## Glacier2.Server.Buffered

### Synopsis

    Glacier2.Server.Buffered=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router queues incoming requests from servers and creates an extra thread for each servers connection that processes the queued requests. If `num` is set to zero, the router operates in unbuffered mode in which a request is forwarded in the same thread that received it. The default value is 1.

| In unbuffered mode, twoway requests from a server are serialized, and nested twoway requests are not supported.

| Unbuffered mode for server requests is susceptible to a denial-of-service attack from hostile clients. Use caution!

## Glacier2.SessionManager

### Synopsis

    Glacier2.SessionManager=proxy

### Description

Specifies the proxy of an object that implements the `Glacier2::SessionManager` interface. The router invokes this proxy to create a new session for a client, but only after the router validates the client's username and password.

## Glacier2.SessionManager.CloseCount

### Synopsis

    Glacier2.SessionManager.CloseCount=num

### Description

If `num` is set to a value larger than zero, it represents the maxmimum number of invocations the router makes on on the session manager proxy over a single connection. After the maximum is reached, the router establishes a new connection to the session manager. Existing connections remain open and are closed when no longer in use. This property is useful when the session manager is a replicated object because, with each new connection, the router might use a session manager in a different server. If not defined or set to zero, the router maintains a single connection to the session manager indefinitely.

## Glacier2.SessionTimeout

### Synopsis

    Glacier2.SessionTimeout=num

### Description

If `num` is set to a value larger than zero, a client's session with the Glacier2 router expires after the specified `num` seconds of inactivity. The default value is 0, meaning sessions do not expire due to inactivity.

| It is important that `num` be chosen so that client sessions do not expire prematurely.

## Glacier2.Trace.RoutingTable

### Synopsis

    Glacier2.Trace.RoutingTable=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs a trace message for each new proxy that is added to the router's internal routing table. The default value is 0.

## Glacier2.Trace.Session

### Synopsis

    Glacier2.Trace.Session=num

### Description

If `num` is set to a value larger than zero, the Glacier2 router logs trace messages about session-related activities. The default value is 0.

<<< Previous | Home | Next >>>
IceStorm Properties | Up | Freeze Properties